*-----------------------------------------------------------------------
*     SWPACK
*-----------------------------------------------------------------------
*     Copyright (C) 2000 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
#ifdef HAVE_CONFIG_H
#  include "../../../config.h"
#endif
      SUBROUTINE SWDOPN

      INTEGER   IMAGE(*)
      REAL      WPX(*), WPY(*)
      LOGICAL   LWDATR, LCLATR, LTNATR, LIMATR, LPTATR
      CHARACTER COBJ*(*), COMM*(*)

      LOGICAL   LWAIT, LWAIT0, LWAIT1, LKEY, LDUMP, LALT,
     +          LCOLOR, LSEP,LPRINT
      CHARACTER CMSG*80, CLRMAP*80, CBTMAP*80, CLPR*80, COUT*80, CTTL*80
#ifdef HAVE_GTK_H && HAVE_GDK_IMLIB_H
      LOGICAL   LWND
      CHARACTER CIMFMT*8
#endif

      SAVE


*     / OPEN ( AND ACTIVATE ) WORKSTATION /

      CALL SGIGET('IWS', JWS)
      CALL SWIGET('IWS', IWS)

      CMSG='GRPH1 : STARTED / IWS = ##.'
      CALL CHNGI(CMSG,'##',JWS,'(I2)')
      CALL MSGDMP('M','SWDOPN',CMSG)

*     / DEVICE DEPENDENT PARAMETERS /
#ifdef HAVE_GTK_H
      IF (IWS.EQ.1 .OR. IWS.EQ.2 .OR. IWS.EQ.4) THEN
#else
      IF (IWS.EQ.1 .OR. IWS.EQ.2) THEN
#endif

        CALL SWIGET('IWIDTH ', IWIDTH)
        CALL SWIGET('IHEIGHT', IHEIGH)
        CALL SWCGET('FNAME  ', COUT  )
        CALL SWCGET('TITLE  ', CTTL  )

        CALL SWQFNM('CLRMAP ', CLRMAP)
        IF (CLRMAP.EQ.' ') THEN
          CALL MSGDMP('E','SWDOPN','COLORMAP FILE DOES NOT EXIST.')
        END IF

        IF (COUT.EQ.' ' .OR. COUT.EQ.'*') CALL OSGARG(0, COUT)
        IF (COUT.EQ.' ') THEN
          COUT = 'DCL'
          CALL CLOWER(COUT)
        END IF

        IF (CTTL.EQ.' ' .OR. CTTL.EQ.'*') CALL DCLVNM(CTTL)

      END IF

      IF (IWS.EQ.1) THEN

        CALL SWIGET('IPOSX  ', IPOSX )
        CALL SWIGET('IPOSY  ', IPOSY )
        CALL SWLGET('LWAIT  ', LWAIT )
        CALL SWLGET('LWAIT0 ', LWAIT0)
        CALL SWLGET('LWAIT1 ', LWAIT1)
        CALL SWLGET('LKEY   ', LKEY  )
        CALL SWLGET('LALT   ', LALT  )
        CALL SWLGET('LDUMP  ', LDUMP )

        CALL SWQFNM('BITMAP ', CBTMAP)
        IF (CBTMAP.EQ.' ') THEN
          CALL MSGDMP('E','SWDOPN','BITMAP FILE DOES NOT EXIST.')
        END IF

        CALL ZXDOPN(IWIDTH, IHEIGH, IPOSX, IPOSY,
     +       LWAIT, LWAIT0, LWAIT1, LKEY, LALT, LDUMP,
     +       CLRMAP, CBTMAP, COUT, CTTL)

      ELSE IF (IWS.EQ.2) THEN

        CALL SWLGET('LCOLOR ', LCOLOR)
        CALL SWLGET('LSEP   ', LSEP  )
        CALL SWLGET('LPRINT ', LPRINT)
        CALL SWCGET('LPR    ', CLPR  )

        CALL Z1DOPN(IWIDTH, IHEIGH, LCOLOR, LSEP, LPRINT,
     +       CLRMAP, COUT, CTTL, CLPR)

      ELSE IF (IWS.EQ.3) THEN

        CALL SWLGET('LWAIT  ', LWAIT)
        CALL GLIGET('NLNSIZE',NLNSZ0)
        CALL SWIGET('NLNSIZE',NLNSIZ)
        CALL GLISET('NLNSIZE',NLNSIZ)

        CALL ZTDOPN(LWAIT)

#ifdef HAVE_GTK_H
      ELSE IF (IWS.EQ.4) THEN

        CALL SWIGET('IPOSX  ', IPOSX )
        CALL SWIGET('IPOSY  ', IPOSY )
        CALL SWLGET('LWAIT  ', LWAIT )
        CALL SWLGET('LWAIT0 ', LWAIT0)
        CALL SWLGET('LWAIT1 ', LWAIT1)
        CALL SWLGET('LKEY   ', LKEY  )
        CALL SWLGET('LDUMP  ', LDUMP )

        CALL SWQFNM('BITMAP ', CBTMAP)
        IF (CBTMAP.EQ.' ') THEN
          CALL MSGDMP('E','SWDOPN','BITMAP FILE DOES NOT EXIST.')
        END IF

#ifdef HAVE_GDK_IMLIB_H

        CALL SWLGET('LWND   ', LWND  )

        CALL SWCGET('CIMFMT ', CIMFMT)

        CALL ZGDOPN(IWIDTH, IHEIGH, IPOSX, IPOSY,
     +       LWAIT, LWAIT0, LWAIT1, LKEY, LDUMP, LWND,
     +       CIMFMT, CLRMAP, CBTMAP, COUT, CTTL)
#else
        CALL ZGDOPN(IWIDTH, IHEIGH, IPOSX, IPOSY,
     +       LWAIT, LWAIT0, LWAIT1, LKEY, LDUMP,
     +       CLRMAP, CBTMAP, COUT, CTTL)
#endif
#endif
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWDCLS

*     / ( DEACTIVATE AND ) CLOSE WORKSTATION /

      IF (IWS.EQ.1) CALL ZXDCLS
      IF (IWS.EQ.2) CALL Z1DCLS
      IF (IWS.EQ.3) THEN
        CALL ZTDCLS
        CALL GLISET('NLNSIZE',NLNSZ0)
      END IF
#ifdef HAVE_GTK_H
      IF (IWS.EQ.4) CALL ZGDCLS
#endif
      CMSG='GRPH1 : TERMINATED.'
      CALL MSGDMP('M','SWDCLS',CMSG)

      RETURN
*-----------------------------------------------------------------------
*     PAGE
*-----------------------------------------------------------------------
      ENTRY SWPOPN

*     / OPEN PAGE ( OR SCREEN ) /

      IF (IWS.EQ.1) CALL ZXPOPN
      IF (IWS.EQ.2) CALL Z1POPN
      IF (IWS.EQ.3) CALL ZTPOPN
#ifdef HAVE_GTK_H
      IF (IWS.EQ.4) CALL ZGPOPN
#endif
      RETURN
*-----------------------------------------------------------------------
      ENTRY SWPCLS

*     / CLOSE PAGE ( OR SCREEN ) /

      NPAGE=NPAGE+1
      CMSG='GRPH1 : PAGE = ### COMPLETED.'
      CALL CHNGI(CMSG,'###',NPAGE,'(I3)')
      CALL MSGDMP('M','SWPCLS',CMSG)

      IF (IWS.EQ.1) CALL ZXPCLS
      IF (IWS.EQ.2) CALL Z1PCLS
      IF (IWS.EQ.3) CALL ZTPCLS(LWAIT)
#ifdef HAVE_GTK_H
      IF (IWS.EQ.4) CALL ZGPCLS
#endif
      RETURN
*-----------------------------------------------------------------------
*     OBJECT
*-----------------------------------------------------------------------
      ENTRY SWOOPN(COBJ, COMM)

*     / OPEN OBJECT /

      IF (IWS.EQ.1) CALL ZXOOPN(COBJ, COMM)
      IF (IWS.EQ.2) CALL Z1OOPN(COBJ, COMM)
      IF (IWS.EQ.3) CALL ZTOOPN(COBJ, COMM)
#ifdef HAVE_GTK_H
      IF (IWS.EQ.4) CALL ZGOOPN(COBJ, COMM)
#endif
      RETURN
*-----------------------------------------------------------------------
      ENTRY SWOCLS(COBJ)

*     / CLOSE OBJECT /

      IF (IWS.EQ.1) CALL ZXOCLS(COBJ)
      IF (IWS.EQ.2) CALL Z1OCLS(COBJ)
      IF (IWS.EQ.3) CALL ZTOCLS(COBJ)
#ifdef HAVE_GTK_H
      IF (IWS.EQ.4) CALL ZGOCLS(COBJ)
#endif
      RETURN
*-----------------------------------------------------------------------
*     LINE
*-----------------------------------------------------------------------
      ENTRY SWSWDI(IWDIDX)

*     / SET LINE WIDTH INDEX /

      IF (IWS.EQ.1) CALL ZXSWDI(IWDIDX)
      IF (IWS.EQ.2) CALL Z1SWDI(IWDIDX)
      IF (IWS.EQ.3) CALL ZTSWDI(IWDIDX)
#ifdef HAVE_GTK_H
      IF (IWS.EQ.4) CALL ZGSWDI(IWDIDX)
#endif
      RETURN
*-----------------------------------------------------------------------
      ENTRY SWSCLI(ICLIDX)

*     / SET LINE COLOR INDEX /

      IF (IWS.EQ.1) CALL ZXSCLI(ICLIDX)
      IF (IWS.EQ.2) CALL Z1SCLI(ICLIDX)
      IF (IWS.EQ.3) CALL ZTSCLI(ICLIDX)
#ifdef HAVE_GTK_H
      IF (IWS.EQ.4) CALL ZGSCLI(ICLIDX)
#endif
      RETURN
*-----------------------------------------------------------------------
      ENTRY SWGOPN

*     / OPEN GRAPHIC SEGMENT /

      IF (IWS.EQ.1) CALL ZXGOPN
      IF (IWS.EQ.2) CALL Z1GOPN
      IF (IWS.EQ.3) CALL ZTGOPN
#ifdef HAVE_GTK_H
      IF (IWS.EQ.4) CALL ZGGOPN
#endif
      RETURN
*-----------------------------------------------------------------------
      ENTRY SWGMOV(WX,WY)

*     / PEN-UP MOVE /

      IF (IWS.EQ.1) CALL ZXGMOV(WX,WY)
      IF (IWS.EQ.2) CALL Z1GMOV(WX,WY)
      IF (IWS.EQ.3) CALL ZTGMOV(WX,WY)
#ifdef HAVE_GTK_H
      IF (IWS.EQ.4) CALL ZGGMOV(WX,WY)
#endif
      RETURN
*-----------------------------------------------------------------------
      ENTRY SWGPLT(WX,WY)

*     / PEN-DOWN MOVE /

      IF (IWS.EQ.1) CALL ZXGPLT(WX,WY)
      IF (IWS.EQ.2) CALL Z1GPLT(WX,WY)
      IF (IWS.EQ.3) CALL ZTGPLT(WX,WY)
#ifdef HAVE_GTK_H
      IF (IWS.EQ.4) CALL ZGGPLT(WX,WY)
#endif
      RETURN
*-----------------------------------------------------------------------
      ENTRY SWGCLS

*     / CLOSE GRAPHIC SEGMENT /

      IF (IWS.EQ.1) CALL ZXGCLS
      IF (IWS.EQ.2) CALL Z1GCLS
      IF (IWS.EQ.3) CALL ZTGCLS
#ifdef HAVE_GTK_H
      IF (IWS.EQ.4) CALL ZGGCLS
#endif
      RETURN
*-----------------------------------------------------------------------
*     TONE
*-----------------------------------------------------------------------
      ENTRY SWGTON(NP,WPX,WPY,ITPAT)

*     / HARD FILL /

      IF (IWS.EQ.1) CALL ZXGTON(NP,WPX,WPY,ITPAT)
      IF (IWS.EQ.2) CALL Z1GTON(NP,WPX,WPY,ITPAT)
      IF (IWS.EQ.3) CALL ZTGTON(NP,WPX,WPY,ITPAT)
#ifdef HAVE_GTK_H
      IF (IWS.EQ.4) CALL ZGGTON(NP,WPX,WPY,ITPAT)
#endif
      RETURN
*-----------------------------------------------------------------------
*     IMAGE
*-----------------------------------------------------------------------
      ENTRY SWIOPN(IWX,IWY,IMW,IMH)

*     / OPEN IMAGE /

      IF (IWS.EQ.1) CALL ZXIOPN(IWX, IWY, IMW, IMH)
      IF (IWS.EQ.2) CALL Z1IOPN(IWX, IWY, IMW, IMH)
      IF (IWS.EQ.3) CALL ZTIOPN(IWX, IWY, IMW, IMH)
#ifdef HAVE_GTK_H
      IF (IWS.EQ.4) CALL ZGIOPN(IWX, IWY, IMW, IMH)
#endif
      RETURN
*-----------------------------------------------------------------------
      ENTRY SWIDAT(IMAGE, NLEN)

*     / IMAGE DATA /

      IF (IWS.EQ.1) CALL ZXIDAT(IMAGE, NLEN)
      IF (IWS.EQ.2) CALL Z1IDAT(IMAGE, NLEN)
      IF (IWS.EQ.3) CALL ZTIDAT(IMAGE, NLEN)
#ifdef HAVE_GTK_H
      IF (IWS.EQ.4) CALL ZGIDAT(IMAGE, NLEN)
#endif
      RETURN
*-----------------------------------------------------------------------
      ENTRY SWICLS

*     / IMAGE CLOSE /

      IF (IWS.EQ.1) CALL ZXICLS
      IF (IWS.EQ.2) CALL Z1ICLS
      IF (IWS.EQ.3) CALL ZTICLS
#ifdef HAVE_GTK_H
      IF (IWS.EQ.4) CALL ZGICLS
#endif
      RETURN
*-----------------------------------------------------------------------
*     MOUSE
*-----------------------------------------------------------------------
      ENTRY SWQPNT(WX,WY,MB)

*     / INQUIRE POSITION OF POINTER /

      IF (IWS.EQ.1) CALL ZXQPNT(WX,WY,MB)
      IF (IWS.EQ.2) CALL Z1QPNT(WX,WY,MB)
      IF (IWS.EQ.3) CALL ZTQPNT(WX,WY,MB)
#ifdef HAVE_GTK_H
      IF (IWS.EQ.4) CALL ZGQPNT(WX,WY,MB)
#endif
      RETURN
*-----------------------------------------------------------------------
*     TRANSFORMATION
*-----------------------------------------------------------------------
      ENTRY SWFINT(WX, WY, IWX, IWY)

*     / REAL TO INT /

      IF (IWS.EQ.1) CALL ZXFINT(WX, WY, IWX, IWY)
      IF (IWS.EQ.2) CALL Z1FINT(WX, WY, IWX, IWY)
      IF (IWS.EQ.3) CALL ZTFINT(WX, WY, IWX, IWY)
#ifdef HAVE_GTK_H
      IF (IWS.EQ.4) CALL ZGFINT(WX, WY, IWX, IWY)
#endif
      RETURN
*-----------------------------------------------------------------------
      ENTRY SWIINT(IWX, IWY, WX, WY)

*     / INT TO REAL /

      IF (IWS.EQ.1) CALL ZXIINT(IWX, IWY, WX, WY)
      IF (IWS.EQ.2) CALL Z1IINT(IWX, IWY, WX, WY)
      IF (IWS.EQ.3) CALL ZTIINT(IWX, IWY, WX, WY)
#ifdef HAVE_GTK_H
      IF (IWS.EQ.4) CALL ZGIINT(IWX, IWY, WX, WY)
#endif
      RETURN
*-----------------------------------------------------------------------
*     INQUIRY
*-----------------------------------------------------------------------
      ENTRY SWQWDC(LWDATR)

*     / INQUIRE LINE WIDTH CAPABILITY /

      IF (IWS.EQ.1) CALL ZXQWDC(LWDATR)
      IF (IWS.EQ.2) CALL Z1QWDC(LWDATR)
      IF (IWS.EQ.3) CALL ZTQWDC(LWDATR)
#ifdef HAVE_GTK_H
      IF (IWS.EQ.4) CALL ZGQWDC(LWDATR)
#endif
      RETURN
*-----------------------------------------------------------------------
      ENTRY SWQCLC(LCLATR)

*     / INQUIRE LINE COLOR CAPABILITY /

      IF (IWS.EQ.1) CALL ZXQCLC(LCLATR)
      IF (IWS.EQ.2) CALL Z1QCLC(LCLATR)
      IF (IWS.EQ.3) CALL ZTQCLC(LCLATR)
#ifdef HAVE_GTK_H
      IF (IWS.EQ.4) CALL ZGQCLC(LCLATR)
#endif
      RETURN
*-----------------------------------------------------------------------
      ENTRY SWQTNC(LTNATR)

*     / INQUIRE HARD FILL CAPABILITY /

      IF (IWS.EQ.1) CALL ZXQTNC(LTNATR)
      IF (IWS.EQ.2) CALL Z1QTNC(LTNATR)
      IF (IWS.EQ.3) CALL ZTQTNC(LTNATR)
#ifdef HAVE_GTK_H
      IF (IWS.EQ.4) CALL ZGQTNC(LTNATR)
#endif
      RETURN
*-----------------------------------------------------------------------
      ENTRY SWQIMC(LIMATR)

*     / INQUIRE BIT IMAGE CAPABILITY /

      IF (IWS.EQ.1) CALL ZXQIMC(LIMATR)
      IF (IWS.EQ.2) CALL Z1QIMC(LIMATR)
      IF (IWS.EQ.3) CALL ZTQIMC(LIMATR)
#ifdef HAVE_GTK_H
      IF (IWS.EQ.4) CALL ZGQIMC(LIMATR)
#endif
      RETURN
*-----------------------------------------------------------------------
      ENTRY SWQPTC(LPTATR)

*     / INQUIRE MOUSE POINT CAPABILITY /

      IF (IWS.EQ.1) CALL ZXQPTC(LPTATR)
      IF (IWS.EQ.2) CALL Z1QPTC(LPTATR)
      IF (IWS.EQ.3) CALL ZTQPTC(LPTATR)
#ifdef HAVE_GTK_H
      IF (IWS.EQ.4) CALL ZGQPTC(LPTATR)
#endif
      RETURN
*-----------------------------------------------------------------------
      ENTRY SWQRCT(WSXMN,WSXMX,WSYMN,WSYMX,FACT)

*     / INQUIRE WORKSTATION RECTANGLE /

      IF (IWS.EQ.1) CALL ZXQRCT(WSXMN,WSXMX,WSYMN,WSYMX,FACT)
      IF (IWS.EQ.2) CALL Z1QRCT(WSXMN,WSXMX,WSYMN,WSYMX,FACT)
      IF (IWS.EQ.3) CALL ZTQRCT(WSXMN,WSXMX,WSYMN,WSYMX,FACT)
#ifdef HAVE_GTK_H
      IF (IWS.EQ.4) CALL ZGQRCT(WSXMN,WSXMX,WSYMN,WSYMX,FACT)
#endif
      RETURN
*-----------------------------------------------------------------------
      ENTRY SWSROT(IWTROT)

*     / SET FRAME ROTATION FLAG /

      IF (IWS.EQ.1) CALL ZXSROT(IWTROT)
      IF (IWS.EQ.2) CALL Z1SROT(IWTROT)
      IF (IWS.EQ.3) CALL ZTSROT(IWTROT)
#ifdef HAVE_GTK_H
      IF (IWS.EQ.4) CALL ZGSROT(IWTROT)
#endif
      RETURN
      END
